using System;
using System.Runtime.Serialization;
using System.Xml.Serialization;

namespace BA.ECommerce.Contracts
{

	[XmlRoot(Namespace = "urn://BA.ECommerce.1_0_0.com")]
	[DataContract(Namespace="urn://BA.ECommerce.1_0_0.com")]
	public class PurchaseOrder
	{
		[DataMember(Order=0, IsRequired=true)]
		public string PurchaseOrderID;

		[DataMember(Order = 1, IsRequired = true)]
		public string CustomerNumber;

		[DataMember(Order = 2, IsRequired = true)]
		public DateTime OrderDate;

		[DataMember(Order = 3, IsRequired = true)]
		public DateTime DeliveryDate;

		[DataMember(Order = 4, IsRequired = true)]
		public string OrderDetails;
	}

	[XmlRoot(Namespace = "urn://BA.ECommerce.1_0_0.com")]
	[DataContract(Namespace = "urn://BA.ECommerce.1_0_0.com")]
	public class PurchaseOrderStatus
	{
		[DataContract(Namespace = "urn://BA.ECommerce.1_0_0.com")]
		public enum OrderStatus
		{
			[EnumMember]
			PendingApproval,
			[EnumMember]
			Approved,
			[EnumMember]
			Rejected,
			[EnumMember]
			Shipped
		}

		[DataMember(Order = 0, IsRequired = true)]
		public string PurchaseOrderID;

		[DataMember(Order = 1, IsRequired = true)]
		public string CustomerNumber;

		[DataMember(Order = 2, IsRequired=true)]
		public OrderStatus Status;
	}
}
