using System;
using System.ServiceModel;
using System.Xml.Serialization;

namespace BA.ECommerce.Contracts
{
	#region Unwrapped Message Contracts

	[MessageContract(IsWrapped=false)]
	public class PurchaseOrderMessage
	{
		[MessageBodyMember(Namespace = "urn://BA.ECommerce.1_0_0.com")]
		public PurchaseOrder PurchaseOrder;

		public PurchaseOrderMessage(PurchaseOrder po)
		{
			this.PurchaseOrder = po;
		}

		public PurchaseOrderMessage()
		{
		}
	}

	#endregion

	#region MessageContracts for CheckOrderStatus (Wrapped)

	[MessageContract(IsWrapped=false)]
	public class CheckOrderStatus
	{
		[MessageBodyMember(Namespace = "urn://BA.ECommerce.1_0_0.com")]
		public PurchaseOrder PurchaseOrder;

		public CheckOrderStatus(PurchaseOrder po)
		{
			PurchaseOrder = po;
		}

		public CheckOrderStatus()
		{
		}
	}

	[MessageContract(IsWrapped=false)]
	public class CheckOrderStatusResponse
	{
		[MessageBodyMember(Namespace="urn://BA.ECommerce.1_0_0.com")]
		public PurchaseOrderStatus PurchaseOrderStatus;

		public CheckOrderStatusResponse(PurchaseOrderStatus status)
		{
			PurchaseOrderStatus = status;
		}

		public CheckOrderStatusResponse()
		{
		}
	}

	#endregion

	#region MessagContracts for CancelOrder (Wrapped)

	[XmlRoot(Namespace = "urn://BA.ECommerce.1_0_0.com")]
	[MessageContract(IsWrapped=true, WrapperNamespace="urn://BA.ECommerce.1_0_0.com")]
	public class CancelOrder
	{
		[MessageBodyMember(Namespace = "urn://BA.ECommerce.1_0_0.com")]
		public PurchaseOrder PurchaseOrder;

		public CancelOrder(PurchaseOrder po)
		{
			PurchaseOrder = po;
		}

		public CancelOrder()
		{
		}
	}

	#endregion

	#region MessageContracts for ReceiveOrderStatus (Wrapped)

	[XmlRoot(Namespace = "urn://BA.ECommerce.1_0_0.com")]
	[MessageContract(IsWrapped = true, WrapperNamespace = "urn://BA.ECommerce.1_0_0.com")]
	public class ReceiveOrderStatus
	{
		[MessageBodyMember(Namespace = "urn://BA.ECommerce.1_0_0.com")]
		public PurchaseOrderStatus PurchaseOrderStatus;

		public ReceiveOrderStatus(PurchaseOrderStatus status)
		{
			PurchaseOrderStatus = status;
		}

		public ReceiveOrderStatus()
		{
		}
	}

	#endregion

}
