using System;
using System.ServiceModel;

namespace BA.ECommerce.Contracts
{
	[ServiceContract(Namespace="urn://BA.ECommerce.1_0_0.com")]
	public interface IPurchasing
	{
		// 1-way operation with no explicit MessageContract
		[OperationContract(/*IsOneWay=true // setting to true will make it incompatablie with BizTalk*/)]
		void PlaceOrder(PurchaseOrder PurchaseOrder);

		// 2-way asynchronous operation with unwrapped MessageContract
		[OperationContract]
		void PlaceOrderWithApproval(PurchaseOrderMessage request);

		// 2-way synchronous operation with unwrapped MessageContracts
		[OperationContract]
		CheckOrderStatusResponse CheckOrderStatus(CheckOrderStatus request);

		// 2-way asynchronous pair of operations with unwrapped MessageContracts
		[OperationContract]
		void CancelOrder(CancelOrder request);
		// void CancelOrder(PurchaseOrder po);
	}

	[ServiceContract(Namespace = "urn://BA.ECommerce.1_0_0.com")]
	public interface IPurchasingClient
	{
		// Asynchronous callback from IPurchasing.CancelOrder, with wrapped MessageContract
		[OperationContract]
		void ReceiveOrderStatus(ReceiveOrderStatus request);
	}

}
