using System;
using System.Diagnostics;
using System.ServiceModel;

using BA.ECommerce.Contracts;

namespace BA.ECommerce.Service
{
	class Program
	{
		static void Main(string[] args)
		{
			BasicHttpBinding httpBinding = new BasicHttpBinding();
			string httpAddress = "http://localhost:5555/";
			ServiceHost httpHost = new ServiceHost(
				typeof(Purchasing), 
				new Uri(httpAddress));
			httpHost.AddServiceEndpoint(
				typeof(IPurchasing), 
				httpBinding, 
				"BA.ECommerce.Purchasing");

			NetTcpBinding tcpBinding = new NetTcpBinding();
			string tcpAddress = "net.tcp://localhost:9000/";
			ServiceHost tcpHost = new ServiceHost(
				typeof(Purchasing),
				new Uri(tcpAddress));
			tcpHost.AddServiceEndpoint(
				typeof(IPurchasing),
				tcpBinding,
				"BA.ECommerce.Purchasing");

			using (httpHost)
			{
				using (tcpHost)
				{
					try
					{
						httpHost.Open();
						tcpHost.Open();
						Console.WriteLine("Press any key to stop the service.\n");
						Console.Read();
					}
					catch (Exception ex)
					{
						Console.WriteLine(ex);
						Trace.WriteLine(ex);
						Console.Read();
					}
				}
			}
		}
	}
}
