using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.ServiceModel;

using Contracts;

namespace Client
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void btnSubmit_Click(object sender, EventArgs e)
		{
			string address = "net.tcp://localhost:3333/BA.Employment.StateMachine";

			IEmploymentProcessingStep proxy = ChannelFactory<IEmploymentProcessingStep>.CreateChannel(
				new NetTcpBinding(),
				new EndpointAddress(address));
			using (proxy as IDisposable)
			{
				try
				{
					JobApplicant applicant = new JobApplicant();
					applicant.Name = txtName.Text;
					applicant.SSN = txtSSN.Text;
					applicant.Position = txtPosition.Text;
					applicant.Salary = Decimal.Parse(txtSalary.Text);
					applicant.Citizenship = txtCitizenship.Text;

					EmploymentProcessingState processingState = new EmploymentProcessingState(applicant);
					processingState.CurrentStep = "Begin";
					EmploymentProcessingStepMessage request = new EmploymentProcessingStepMessage(processingState);

					proxy.DoStep(request);
				}
				catch (Exception ex)
				{
					Console.WriteLine(ex);
					Trace.WriteLine(ex);
					Console.Read();
				}
			}
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			txtName.Text = "Tom Brown";
			txtSSN.Text = "111-22-3333";
			txtPosition.Text = "Desk Clerk";
			txtSalary.Text = "24000";
			txtCitizenship.Text = "US";
		}
	}
}