using System;
using System.Runtime.Serialization;
using System.Xml.Serialization;

namespace Contracts
{

	[DataContract(Namespace = "urn://BA.Employment.1_0_0.com")]
	public class JobApplicant
	{
		[DataMember(IsRequired = true, Order = 0)]
		public string Name;

		[DataMember(IsRequired = true, Order = 1)]
		public string SSN;
		
		[DataMember(IsRequired = true, Order = 2)]
		public string Position;
		
		[DataMember(IsRequired = true, Order = 3)]
		public Decimal Salary;
		
		[DataMember(IsRequired = true, Order = 4)]
		public string Citizenship;
	}

	[XmlRoot(Namespace = "urn://BA.Employment.1_0_0.com")]
	[DataContract(Namespace = "urn://BA.Employment.1_0_0.com")]
	public class EmploymentProcessingState
	{
		[DataMember(IsRequired = true, Order = 0)]
		public string[] Steps;
		
		[DataMember(IsRequired = true, Order = 1)]
		public string CurrentStep;
		
		[DataMember(IsRequired = true, Order = 2)]
		public JobApplicant Applicant;

		public EmploymentProcessingState(JobApplicant applicant)
			: this()
		{
			Applicant = applicant;
		}

		public EmploymentProcessingState()
		{
		}
	}
}
