using System;
using System.Diagnostics;
using System.ServiceModel;

using Contracts;

namespace Services
{
	internal static class CallNextStep
	{

		public static void Call(EmploymentProcessingStepMessage request)
		{
			string address = "net.tcp://localhost:3333/BA.Employment.StateMachine";
			NetTcpBinding binding = new NetTcpBinding();

			IEmploymentProcessingStep proxy = ChannelFactory<IEmploymentProcessingStep>.CreateChannel(
				binding,
				new EndpointAddress(address));
			using (proxy as IDisposable)
			{
				try
				{
					proxy.DoStep(request);
				}
				catch (Exception ex)
				{
					Console.WriteLine(ex);
					Trace.WriteLine(ex);
					Console.Read();
				}
			}
		}
	
	}
}
