using System;
using System.Collections.Generic;

using Contracts;

namespace Services
{
	public class InitializeStepList : IEmploymentProcessingStep
	{

		#region IEmploymentProcessingStep Members

		public void DoStep(EmploymentProcessingStepMessage stepRequest)
		{
			Console.WriteLine("\n{0}: Initializing hiring steps list",
							stepRequest.ProcessingState.Applicant.Name);

			List<string> steps = new List<string>();

			if (stepRequest.ProcessingState.Applicant.Position == "Manager" ||
				stepRequest.ProcessingState.Applicant.Position == "Bank Teller" ||
				stepRequest.ProcessingState.Applicant.Position == "Body Guard")
			{
				steps.Add("CheckCriminalRecord");
			}

			if (stepRequest.ProcessingState.Applicant.Salary > 40000M)
			{
				steps.Add("CheckCreditHistory");
			}

			if (stepRequest.ProcessingState.Applicant.Citizenship != "US")
			{
				steps.Add("CheckImmigrationStatus");
			}

			steps.Add("ConductJobInterview");
			steps.Add("MakeHiringDecision");
			steps.Add("TerminateProcess");

			stepRequest.ProcessingState.Steps = steps.ToArray();
			stepRequest.ProcessingState.CurrentStep = steps[0];

			CallNextStep.Call(stepRequest);
		}

		#endregion
	}
}
